org.apache.struts2.portlet.result

## Class PortletVelocityResult

- java.lang.Object
- - org.apache.struts2.result.StrutsResultSupport
  - - org.apache.struts2.portlet.result.PortletVelocityResult

- All Implemented Interfaces:
    Serializable, Result, StrutsStatics

      public class PortletVelocityResult
      extends StrutsResultSupport

  Using the Servlet container's `JspFactory`, this result mocks a JSP execution environment and then displays a Velocity template that will be streamed directly to the servlet output.

  This result type takes the following parameters:

  - location (default) - the location of the template to process.
  - parse - true by default. If set to false, the location param will not be parsed for Ognl expressions.

  This result follows the same rules from `StrutsResultSupport`.

  Example:

       <!-- START SNIPPET: example -->
        <result name="success" type="velocity">
          <param name="location">foo.vm</param>
        </result>
        <!-- END SNIPPET: example -->

  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.opensymphony.xwork2.Result

      `Result.LegacyAdapter`

  - ### Field Summary

    - ### Fields inherited from class org.apache.struts2.result.StrutsResultSupport

      `DEFAULT_PARAM, DEFAULT_URL_ENCODING, parseLocation`

    - ### Fields inherited from interface org.apache.struts2.StrutsStatics

      `ACTION_MAPPING, HTTP_REQUEST, HTTP_RESPONSE, PAGE_CONTEXT, SERVLET_CONTEXT, SERVLET_DISPATCHER, STRUTS_ACTION_TAG_INVOCATION, STRUTS_PORTLET_CONTEXT`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PortletVelocityResult()`
    `PortletVelocityResult(String location)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected org.apache.velocity.context.Context` | `createContext(VelocityManagerInterface velocityManager, ValueStack stack, javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response, String location)` Creates the VelocityContext that we'll use to render this page.
    `protected org.apache.velocity.context.Context` | `createContext(VelocityManager velocityManager, ValueStack stack, javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response, String location)` Deprecated. since 6.4.0
    `void` | `doExecute(String location, ActionInvocation invocation)`
    `void` | `executeRenderResult(String finalLocation, ActionInvocation invocation)` Creates a Velocity context from the action, loads a Velocity template and executes the template.
    `protected String` | `getContentType(String templateLocation)` Retrieve the content type for this template.
    `protected String` | `getEncoding(String templateLocation)` Retrieve the encoding for this template.
    `protected org.apache.velocity.Template` | `getTemplate(ValueStack stack, org.apache.velocity.app.VelocityEngine velocity, ActionInvocation invocation, String location, String encoding)` Given a value stack, a Velocity engine, and an action invocation, this method returns the appropriate Velocity template to render.
    `void` | `setDefaultEncoding(String encoding)`
    `void` | `setVelocityManager(VelocityManager mgr)` Deprecated. since 6.4.0
    `void` | `setVelocityManager(VelocityManagerInterface mgr)`

    - ### Methods inherited from class org.apache.struts2.result.StrutsResultSupport

      `conditionalParse, conditionalParseCollection, doExecute, execute, getLastFinalLocation, getLocation, setEncode, setLocation, setParse`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.opensymphony.xwork2.Result

      `adapt, execute`

- - ### Constructor Detail

    - #### PortletVelocityResult

          public PortletVelocityResult()

    - #### PortletVelocityResult

          public PortletVelocityResult(String location)

  - ### Method Detail

    - #### setVelocityManager

          public void setVelocityManager(VelocityManagerInterface mgr)

    - #### setVelocityManager

          @Deprecated
          public void setVelocityManager(VelocityManager mgr)

      Deprecated. since 6.4.0

    - #### setDefaultEncoding

          public void setDefaultEncoding(String encoding)

    - #### doExecute

          public void doExecute(String location,
                                ActionInvocation invocation)
                         throws Exception

      Overrides:
        `doExecute` in class `StrutsResultSupport`
      Throws:
        `Exception`

    - #### executeRenderResult

          public void executeRenderResult(String finalLocation,
                                          ActionInvocation invocation)
                                   throws Exception

      Creates a Velocity context from the action, loads a Velocity template and executes the template. Output is written to the servlet output stream.
      Parameters:
        `finalLocation` - the location of the Velocity template
        `invocation` - an encapsulation of the action execution state.
      Throws:
        `Exception` - if an error occurs when creating the Velocity context, loading or executing the template or writing output to the servlet response stream.

    - #### getContentType

          protected String getContentType(String templateLocation)

      Retrieve the content type for this template.
      People can override this method if they want to provide specific content types for specific templates (eg text/xml).
      Parameters:
        `templateLocation` - location of templates
      Returns:
        The content type associated with this template (default "text/html")

    - #### getEncoding

          protected String getEncoding(String templateLocation)

      Retrieve the encoding for this template.
      People can override this method if they want to provide specific encodings for specific templates.
      Parameters:
        `templateLocation` - location of templates
      Returns:
        The encoding associated with this template (defaults to the value of 'struts.i18n.encoding' property)

    - #### getTemplate

          protected org.apache.velocity.Template getTemplate(ValueStack stack,
                                                             org.apache.velocity.app.VelocityEngine velocity,
                                                             ActionInvocation invocation,
                                                             String location,
                                                             String encoding)
                                                      throws Exception

      Given a value stack, a Velocity engine, and an action invocation, this method returns the appropriate Velocity template to render.
      Parameters:
        `stack` - the value stack to resolve the location again (when parse equals true)
        `velocity` - the velocity engine to process the request against
        `invocation` - an encapsulation of the action execution state.
        `location` - the location of the template
        `encoding` - the charset encoding of the template
      Returns:
        the template to render
      Throws:
        `Exception` - when the requested template could not be found

    - #### createContext

          protected org.apache.velocity.context.Context createContext(VelocityManagerInterface velocityManager,
                                                                      ValueStack stack,
                                                                      javax.servlet.http.HttpServletRequest request,
                                                                      javax.servlet.http.HttpServletResponse response,
                                                                      String location)

      Creates the VelocityContext that we'll use to render this page.
      Parameters:
        `velocityManager` - a reference to the velocityManager to use
        `stack` - the value stack to resolve the location against (when parse equals true)
        `request` - servlet request
        `response` - servlet response
        `location` - the name of the template that is being used
      Returns:
        the a minted Velocity context.

    - #### createContext

          @Deprecated
          protected org.apache.velocity.context.Context createContext(VelocityManager velocityManager,
                                                                                  ValueStack stack,
                                                                                  javax.servlet.http.HttpServletRequest request,
                                                                                  javax.servlet.http.HttpServletResponse response,
                                                                                  String location)

      Deprecated. since 6.4.0

Copyright © 2000–2026 Apache Software Foundation. All rights reserved.